/* valaccodefunctiondeclarator.c generated by valac, the Vala compiler
 * generated from valaccodefunctiondeclarator.vala, do not modify */

/* valaccodefunctiondeclarator.vala
 *
 * Copyright (C) 2006-2007  Jürg Billeter
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 */

#include <glib.h>
#include <glib-object.h>
#include "valaccode.h"
#include <stdlib.h>
#include <string.h>
#include <valagee.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))
#define _vala_ccode_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_ccode_node_unref (var), NULL)))

struct _ValaCCodeFunctionDeclaratorPrivate {
	gchar* _name;
	ValaList* parameters;
};


static gpointer vala_ccode_function_declarator_parent_class = NULL;

#define VALA_CCODE_FUNCTION_DECLARATOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALA_TYPE_CCODE_FUNCTION_DECLARATOR, ValaCCodeFunctionDeclaratorPrivate))
static void vala_ccode_function_declarator_real_write (ValaCCodeNode* base, ValaCCodeWriter* writer);
static void vala_ccode_function_declarator_real_write_declaration (ValaCCodeNode* base, ValaCCodeWriter* writer);
static void vala_ccode_function_declarator_finalize (ValaCCodeNode * obj);


ValaCCodeFunctionDeclarator* vala_ccode_function_declarator_construct (GType object_type, const gchar* name) {
	ValaCCodeFunctionDeclarator* self = NULL;
	const gchar* _tmp0_;
	g_return_val_if_fail (name != NULL, NULL);
	self = (ValaCCodeFunctionDeclarator*) vala_ccode_declarator_construct (object_type);
	_tmp0_ = name;
	vala_ccode_function_declarator_set_name (self, _tmp0_);
	return self;
}


ValaCCodeFunctionDeclarator* vala_ccode_function_declarator_new (const gchar* name) {
	return vala_ccode_function_declarator_construct (VALA_TYPE_CCODE_FUNCTION_DECLARATOR, name);
}


/**
 * Appends the specified parameter to the list of function parameters.
 *
 * @param param a formal parameter
 */
void vala_ccode_function_declarator_add_parameter (ValaCCodeFunctionDeclarator* self, ValaCCodeParameter* param) {
	ValaList* _tmp0_;
	ValaCCodeParameter* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (param != NULL);
	_tmp0_ = self->priv->parameters;
	_tmp1_ = param;
	vala_collection_add ((ValaCollection*) _tmp0_, _tmp1_);
}


static void vala_ccode_function_declarator_real_write (ValaCCodeNode* base, ValaCCodeWriter* writer) {
	ValaCCodeFunctionDeclarator * self;
	ValaCCodeWriter* _tmp0_;
	self = (ValaCCodeFunctionDeclarator*) base;
	g_return_if_fail (writer != NULL);
	_tmp0_ = writer;
	vala_ccode_node_write_declaration ((ValaCCodeNode*) self, _tmp0_);
}


static gpointer _vala_iterable_ref0 (gpointer self) {
	return self ? vala_iterable_ref (self) : NULL;
}


static void vala_ccode_function_declarator_real_write_declaration (ValaCCodeNode* base, ValaCCodeWriter* writer) {
	ValaCCodeFunctionDeclarator * self;
	ValaCCodeWriter* _tmp0_;
	ValaCCodeWriter* _tmp1_;
	const gchar* _tmp2_;
	ValaCCodeWriter* _tmp3_;
	gboolean _tmp4_ = FALSE;
	ValaCCodeModifiers _tmp5_;
	ValaCCodeModifiers _tmp6_;
	gboolean has_args = FALSE;
	gint i = 0;
	gint format_arg_index = 0;
	gint args_index = 0;
	ValaCCodeWriter* _tmp43_;
	ValaCCodeModifiers _tmp44_;
	ValaCCodeModifiers _tmp45_;
	ValaCCodeModifiers _tmp47_;
	ValaCCodeModifiers _tmp48_;
	self = (ValaCCodeFunctionDeclarator*) base;
	g_return_if_fail (writer != NULL);
	_tmp0_ = writer;
	vala_ccode_writer_write_string (_tmp0_, "(*");
	_tmp1_ = writer;
	_tmp2_ = self->priv->_name;
	vala_ccode_writer_write_string (_tmp1_, _tmp2_);
	_tmp3_ = writer;
	vala_ccode_writer_write_string (_tmp3_, ") (");
	_tmp5_ = vala_ccode_node_get_modifiers ((ValaCCodeNode*) self);
	_tmp6_ = _tmp5_;
	if ((_tmp6_ & VALA_CCODE_MODIFIERS_PRINTF) == VALA_CCODE_MODIFIERS_PRINTF) {
		_tmp4_ = TRUE;
	} else {
		ValaCCodeModifiers _tmp7_;
		ValaCCodeModifiers _tmp8_;
		_tmp7_ = vala_ccode_node_get_modifiers ((ValaCCodeNode*) self);
		_tmp8_ = _tmp7_;
		_tmp4_ = (_tmp8_ & VALA_CCODE_MODIFIERS_SCANF) == VALA_CCODE_MODIFIERS_SCANF;
	}
	has_args = _tmp4_;
	i = 0;
	format_arg_index = -1;
	args_index = -1;
	{
		ValaList* _param_list = NULL;
		ValaList* _tmp9_;
		ValaList* _tmp10_;
		gint _param_size = 0;
		ValaList* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		gint _param_index = 0;
		_tmp9_ = self->priv->parameters;
		_tmp10_ = _vala_iterable_ref0 (_tmp9_);
		_param_list = _tmp10_;
		_tmp11_ = _param_list;
		_tmp12_ = vala_collection_get_size ((ValaCollection*) _tmp11_);
		_tmp13_ = _tmp12_;
		_param_size = _tmp13_;
		_param_index = -1;
		while (TRUE) {
			gint _tmp14_;
			gint _tmp15_;
			gint _tmp16_;
			ValaCCodeParameter* param = NULL;
			ValaList* _tmp17_;
			gint _tmp18_;
			gpointer _tmp19_;
			gint _tmp20_;
			ValaCCodeParameter* _tmp22_;
			ValaCCodeWriter* _tmp23_;
			ValaCCodeParameter* _tmp24_;
			ValaCCodeModifiers _tmp25_;
			ValaCCodeModifiers _tmp26_;
			gboolean _tmp28_ = FALSE;
			gboolean _tmp29_;
			gint _tmp42_;
			_tmp14_ = _param_index;
			_param_index = _tmp14_ + 1;
			_tmp15_ = _param_index;
			_tmp16_ = _param_size;
			if (!(_tmp15_ < _tmp16_)) {
				break;
			}
			_tmp17_ = _param_list;
			_tmp18_ = _param_index;
			_tmp19_ = vala_list_get (_tmp17_, _tmp18_);
			param = (ValaCCodeParameter*) _tmp19_;
			_tmp20_ = i;
			if (_tmp20_ > 0) {
				ValaCCodeWriter* _tmp21_;
				_tmp21_ = writer;
				vala_ccode_writer_write_string (_tmp21_, ", ");
			}
			_tmp22_ = param;
			_tmp23_ = writer;
			vala_ccode_node_write ((ValaCCodeNode*) _tmp22_, _tmp23_);
			_tmp24_ = param;
			_tmp25_ = vala_ccode_node_get_modifiers ((ValaCCodeNode*) _tmp24_);
			_tmp26_ = _tmp25_;
			if ((_tmp26_ & VALA_CCODE_MODIFIERS_FORMAT_ARG) == VALA_CCODE_MODIFIERS_FORMAT_ARG) {
				gint _tmp27_;
				_tmp27_ = i;
				format_arg_index = _tmp27_;
			}
			_tmp29_ = has_args;
			if (_tmp29_) {
				ValaCCodeParameter* _tmp30_;
				gboolean _tmp31_;
				gboolean _tmp32_;
				_tmp30_ = param;
				_tmp31_ = vala_ccode_parameter_get_ellipsis (_tmp30_);
				_tmp32_ = _tmp31_;
				_tmp28_ = _tmp32_;
			} else {
				_tmp28_ = FALSE;
			}
			if (_tmp28_) {
				gint _tmp33_;
				_tmp33_ = i;
				args_index = _tmp33_;
			} else {
				gboolean _tmp34_ = FALSE;
				gboolean _tmp35_ = FALSE;
				gboolean _tmp36_;
				_tmp36_ = has_args;
				if (_tmp36_) {
					ValaCCodeParameter* _tmp37_;
					const gchar* _tmp38_;
					const gchar* _tmp39_;
					_tmp37_ = param;
					_tmp38_ = vala_ccode_parameter_get_type_name (_tmp37_);
					_tmp39_ = _tmp38_;
					_tmp35_ = g_strcmp0 (_tmp39_, "va_list") == 0;
				} else {
					_tmp35_ = FALSE;
				}
				if (_tmp35_) {
					gint _tmp40_;
					_tmp40_ = format_arg_index;
					_tmp34_ = _tmp40_ < 0;
				} else {
					_tmp34_ = FALSE;
				}
				if (_tmp34_) {
					gint _tmp41_;
					_tmp41_ = i;
					format_arg_index = _tmp41_ - 1;
				}
			}
			_tmp42_ = i;
			i = _tmp42_ + 1;
			_vala_ccode_node_unref0 (param);
		}
		_vala_iterable_unref0 (_param_list);
	}
	_tmp43_ = writer;
	vala_ccode_writer_write_string (_tmp43_, ")");
	_tmp44_ = vala_ccode_node_get_modifiers ((ValaCCodeNode*) self);
	_tmp45_ = _tmp44_;
	if ((_tmp45_ & VALA_CCODE_MODIFIERS_DEPRECATED) == VALA_CCODE_MODIFIERS_DEPRECATED) {
		ValaCCodeWriter* _tmp46_;
		_tmp46_ = writer;
		vala_ccode_writer_write_string (_tmp46_, " G_GNUC_DEPRECATED");
	}
	_tmp47_ = vala_ccode_node_get_modifiers ((ValaCCodeNode*) self);
	_tmp48_ = _tmp47_;
	if ((_tmp48_ & VALA_CCODE_MODIFIERS_PRINTF) == VALA_CCODE_MODIFIERS_PRINTF) {
		gint _tmp49_ = 0;
		gint _tmp50_;
		ValaCCodeWriter* _tmp53_;
		gint _tmp54_;
		gint _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
		_tmp50_ = format_arg_index;
		if (_tmp50_ >= 0) {
			gint _tmp51_;
			_tmp51_ = format_arg_index;
			_tmp49_ = _tmp51_ + 1;
		} else {
			gint _tmp52_;
			_tmp52_ = args_index;
			_tmp49_ = _tmp52_;
		}
		format_arg_index = _tmp49_;
		_tmp53_ = writer;
		_tmp54_ = format_arg_index;
		_tmp55_ = args_index;
		_tmp56_ = g_strdup_printf (" G_GNUC_PRINTF(%d,%d)", _tmp54_, _tmp55_ + 1);
		_tmp57_ = _tmp56_;
		vala_ccode_writer_write_string (_tmp53_, _tmp57_);
		_g_free0 (_tmp57_);
	} else {
		ValaCCodeModifiers _tmp58_;
		ValaCCodeModifiers _tmp59_;
		_tmp58_ = vala_ccode_node_get_modifiers ((ValaCCodeNode*) self);
		_tmp59_ = _tmp58_;
		if ((_tmp59_ & VALA_CCODE_MODIFIERS_SCANF) == VALA_CCODE_MODIFIERS_SCANF) {
			gint _tmp60_ = 0;
			gint _tmp61_;
			ValaCCodeWriter* _tmp64_;
			gint _tmp65_;
			gint _tmp66_;
			gchar* _tmp67_;
			gchar* _tmp68_;
			_tmp61_ = format_arg_index;
			if (_tmp61_ >= 0) {
				gint _tmp62_;
				_tmp62_ = format_arg_index;
				_tmp60_ = _tmp62_ + 1;
			} else {
				gint _tmp63_;
				_tmp63_ = args_index;
				_tmp60_ = _tmp63_;
			}
			format_arg_index = _tmp60_;
			_tmp64_ = writer;
			_tmp65_ = format_arg_index;
			_tmp66_ = args_index;
			_tmp67_ = g_strdup_printf (" G_GNUC_SCANF(%d,%d)", _tmp65_, _tmp66_ + 1);
			_tmp68_ = _tmp67_;
			vala_ccode_writer_write_string (_tmp64_, _tmp68_);
			_g_free0 (_tmp68_);
		} else {
			gint _tmp69_;
			_tmp69_ = format_arg_index;
			if (_tmp69_ >= 0) {
				ValaCCodeWriter* _tmp70_;
				gint _tmp71_;
				gchar* _tmp72_;
				gchar* _tmp73_;
				_tmp70_ = writer;
				_tmp71_ = format_arg_index;
				_tmp72_ = g_strdup_printf (" G_GNUC_FORMAT(%d)", _tmp71_ + 1);
				_tmp73_ = _tmp72_;
				vala_ccode_writer_write_string (_tmp70_, _tmp73_);
				_g_free0 (_tmp73_);
			}
		}
	}
}


const gchar* vala_ccode_function_declarator_get_name (ValaCCodeFunctionDeclarator* self) {
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}


void vala_ccode_function_declarator_set_name (ValaCCodeFunctionDeclarator* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_name);
	self->priv->_name = _tmp1_;
}


static void vala_ccode_function_declarator_class_init (ValaCCodeFunctionDeclaratorClass * klass) {
	vala_ccode_function_declarator_parent_class = g_type_class_peek_parent (klass);
	((ValaCCodeNodeClass *) klass)->finalize = vala_ccode_function_declarator_finalize;
	g_type_class_add_private (klass, sizeof (ValaCCodeFunctionDeclaratorPrivate));
	((ValaCCodeNodeClass *) klass)->write = (void (*) (ValaCCodeNode *, ValaCCodeWriter*)) vala_ccode_function_declarator_real_write;
	((ValaCCodeNodeClass *) klass)->write_declaration = (void (*) (ValaCCodeNode *, ValaCCodeWriter*)) vala_ccode_function_declarator_real_write_declaration;
}


static void vala_ccode_function_declarator_instance_init (ValaCCodeFunctionDeclarator * self) {
	GEqualFunc _tmp0_;
	ValaArrayList* _tmp1_;
	self->priv = VALA_CCODE_FUNCTION_DECLARATOR_GET_PRIVATE (self);
	_tmp0_ = g_direct_equal;
	_tmp1_ = vala_array_list_new (VALA_TYPE_CCODE_PARAMETER, (GBoxedCopyFunc) vala_ccode_node_ref, (GDestroyNotify) vala_ccode_node_unref, _tmp0_);
	self->priv->parameters = (ValaList*) _tmp1_;
}


static void vala_ccode_function_declarator_finalize (ValaCCodeNode * obj) {
	ValaCCodeFunctionDeclarator * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_TYPE_CCODE_FUNCTION_DECLARATOR, ValaCCodeFunctionDeclarator);
	_g_free0 (self->priv->_name);
	_vala_iterable_unref0 (self->priv->parameters);
	VALA_CCODE_NODE_CLASS (vala_ccode_function_declarator_parent_class)->finalize (obj);
}


/**
 * Represents a function pointer declarator in the C code.
 */
GType vala_ccode_function_declarator_get_type (void) {
	static volatile gsize vala_ccode_function_declarator_type_id__volatile = 0;
	if (g_once_init_enter (&vala_ccode_function_declarator_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValaCCodeFunctionDeclaratorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_ccode_function_declarator_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaCCodeFunctionDeclarator), 0, (GInstanceInitFunc) vala_ccode_function_declarator_instance_init, NULL };
		GType vala_ccode_function_declarator_type_id;
		vala_ccode_function_declarator_type_id = g_type_register_static (VALA_TYPE_CCODE_DECLARATOR, "ValaCCodeFunctionDeclarator", &g_define_type_info, 0);
		g_once_init_leave (&vala_ccode_function_declarator_type_id__volatile, vala_ccode_function_declarator_type_id);
	}
	return vala_ccode_function_declarator_type_id__volatile;
}



